AddComponentPostInit("economy",function(Economy)
local CUSTOM_TRADER = {
    pigman_hatmaker = { items = {"silk", "bandithat"} }
}
local _GetTradeItems = Economy.GetTradeItems
function Economy:GetTradeItems(traderprefab)
    if CUSTOM_TRADER[traderprefab] then
	--print ("HELLO WORKING!")
        return CUSTOM_TRADER[traderprefab].items
    end
    return _GetTradeItems(self, traderprefab)
end

local _MakeTrade = Economy.MakeTrade
function Economy:MakeTrade(traderprefab,city,inst)
   
if CUSTOM_TRADER[traderprefab] then
	
	
		return "oinc",5
	end
	    --print("TEST TEST TSET")		
		return _MakeTrade(self,traderprefab,city,inst)
    
    end
	
	
	local _GetDelay = Economy.GetDelay
	function Economy:GetDelay(traderprefab,city,inst)
		if CUSTOM_TRADER[traderprefab] then	
	
			return 0
		end
		return _GetDelay(self,traderprefab,city,inst)
	end
end)
local RECIPETABS = GLOBAL.RECIPETABS
local TECH = GLOBAL.TECH
_SHOPTYPES = 
{
    ["DEFAULT"] = {"rocks", "flint", "goldnugget"},

    ["pig_shop_deli"] = {
                            { "ratatouille",     "oinc", 3  },
                            { "monsterlasagna",  "oinc", 2  },
                            { "pumpkincookie",   "oinc", 3  },
                            { "stuffedeggplant", "oinc", 4  },
                            { "frogglebunwich",  "oinc", 5  },
                            { "honeynuggets",    "oinc", 5  },
                            { "perogies",        "oinc", 10 },
                            { "waffles",         "oinc", 10 },
                            { "meatballs",       "oinc", 10 },
                            { "honeyham",        "oinc", 20 },
                            { "turkeydinner",    "oinc", 10 },
                            { "dragonpie",       "oinc", 30 },
                        },
    
    ["pig_shop_florist"] = {
                            { "carrot_seeds",      "oinc", 1  },
                            { "pumpkin_seeds",     "oinc", 1  },
                            { "pomegranate_seeds", "oinc", 1  },
                            { "eggplant_seeds",    "oinc", 1  },
                            { "durian_seeds",      "oinc", 1  },
                            { "corn_seeds",        "oinc", 1  },
                            { "dragonfruit_seeds", "oinc", 10 },
                            { "watermelon_seeds",  "oinc", 1  },
                            { "flowerhat",         "oinc", 2  },
                            { "acorn",             "oinc", 1  },
                            { "pinecone",          "oinc", 1  },
                            { "dug_berrybush2",    "oinc", 2  },
                            { "dug_berrybush",     "oinc", 2  },
							{ "lureplantbulb",     "oinc", 40 },
							{ "fertilizer",        "oinc", 10 },
							{ "dug_elephantcactus","oinc", 20 },
							{ "turf_volcano",      "oinc", 5 },
							{ "dug_coffeebush",    "oinc", 20 },
                        },

    ["pig_shop_general"] = {
                            { "pitchfork",  "oinc", 5  },
                            { "shovel",     "oinc", 5  },
                            { "pickaxe",    "oinc", 5  },
                            { "axe",        "oinc", 5  },
                            { "flint",      "oinc", 1  },
                            { "machete",    "oinc", 5  },
                            { "minerhat",   "oinc", 20 },
                            { "razor",      "oinc", 3  },
                            { "backpack",   "oinc", 5  },
                            { "umbrella",   "oinc", 10 },
                            { "fabric",     "oinc", 5  },
                            { "bugnet",     "oinc", 20 },
                            { "fishingrod", "oinc", 10 },                            
                        },
    ["pig_shop_general_fiesta"] = {                            
                            { "firecrackers",  "oinc", 1  },
                            { "firecrackers",  "oinc", 1  },
                            { "firecrackers",  "oinc", 1  },
                            { "firecrackers",  "oinc", 1  },
                            { "flint",      "oinc", 1  },
                            { "minerhat",   "oinc", 20 },
                            { "backpack",   "oinc", 5  },                            
                            { "fabric",     "oinc", 5  },
                            { "umbrella",   "oinc", 10 },
                            { "bugnet",     "oinc", 20 },                                                                                    
                        },                        

    ["pig_shop_hoofspa"] = {
                            { "blue_cap",     "oinc", 3 },
                            { "green_cap",    "oinc", 2 },
                            { "bandage",      "oinc", 5 },
                            { "healingsalve", "oinc", 4 },
                            { "antivenom",    "oinc", 5 },
                            { "coffeebeans",  "oinc", 2 },
                        },

    ["pig_shop_produce"] = {
                            { "berries",      "oinc", 1 },
                            { "watermelon",   "oinc", 1 },
                            { "sweet_potato", "oinc", 1 },
                            { "carrot",       "oinc", 1 },
                            { "drumstick",    "oinc", 2 },
                            { "eggplant",     "oinc", 2 },
                            { "corn",         "oinc", 2 },
                            { "pumpkin",      "oinc", 3 },
                            { "meat",         "oinc", 5 },
                            { "pomegranate",  "oinc", 1 },
                            { "cave_banana",  "oinc", 1 },
                            { "coconut",      "oinc", 3 },
                            { "froglegs",     "oinc", 2 },
                        },

    ["pig_shop_antiquities"] = {
                            { "silk",              "oinc", 5  },
                            { "gears",             "oinc", 10 },
                            { "mandrake",          "oinc", 50 },
                            { "wormlight",         "oinc", 20 },
                            { "deerclops_eyeball", "oinc", 50 },
                            { "walrus_tusk",       "oinc", 50 },
                            { "bearger_fur",       "oinc", 40 },
                            { "goose_feather",     "oinc", 40 },
                            { "dragon_scales",     "oinc", 30 },
                            { "houndstooth",       "oinc", 5  },
                            { "bamboo",            "oinc", 3  },
                            { "horn",              "oinc", 5  },
                            { "coontail",          "oinc", 4  },
							{ "bill_quill",        "oinc", 10 },
							{ "hippo_antler",      "oinc", 60 },
                        },

    ["pig_shop_cityhall"] = {                       
                        },

    ["pig_shop_arcane"] = {                     
                            { "icestaff",     "oinc", 50 },
                            { "firestaff",    "oinc", 50 },
                            { "amulet",       "oinc", 50 },
                            { "blueamulet",   "oinc", 50 },
                            { "purpleamulet", "oinc", 50 },
                            { "livinglog",    "oinc", 5  },
                            { "armorslurper", "oinc", 20 },
                            { "nightsword",   "oinc", 50 },
                            { "armor_sanity", "oinc", 20 },
                            { "onemanband",   "oinc", 40 },
							{ "krampus_sack", "oinc", 300 },
                        },  
    ["pig_shop_weapons"] = {
                            { "spear",          "oinc", 3  },
                            { "halberd",        "oinc", 5  },
                            { "cutlass",        "oinc", 50 },
                            { "trap_teeth",     "oinc", 10 },
                            { "birdtrap",       "oinc", 20 },
                            { "trap",           "oinc", 2  },
                            { "coconade",       "oinc", 20 },
                            { "blowdart_pipe",  "oinc", 10 },
                            { "blowdart_sleep", "oinc", 10 },
                            { "boomerang",      "oinc", 10 },
                        },                      
    ["pig_shop_hatshop"] = {                        
                            { "winterhat",   "oinc", 10 },
                            { "tophat",      "oinc", 10 },
                            { "earmuffshat", "oinc", 5  },
                            { "walrushat",   "oinc", 50 },
                            { "molehat",     "oinc", 20 },
                            { "catcoonhat",  "oinc", 10 },
                            { "captainhat",  "oinc", 20 },
                            { "featherhat",  "oinc", 5  },
                            { "strawhat",    "oinc", 3  },
                            { "beefalohat",  "oinc", 10 },
                            { "pithhat",     "oinc", 10 },
                        },  
    ["pig_shop_bank"] = {                        
                            { "goldnugget",  "oinc", 10 },
                            { "oinc10",      "oinc", 10 },
                            { "oinc100",     "oinc", 100  },
                        },

                        -- MAKE SURE TO ADD A RECIPE TO RECIPES.LUA FOR THINGS ADDED HERE SO THEY CAN BE CRAFTED WITHOUT THE DLC
    ["pig_shop_tinker"] = {                        
                            { "eyebrellahat_blueprint",         "oinc", 50 },
                            { "cane_blueprint",                 "oinc", 50 },
                            { "icepack_blueprint",              "oinc", 50 },
                            { "staff_tornado_blueprint",        "oinc", 50 },
                            { "armordragonfly_blueprint",       "oinc", 100 },
                            { "dragonflychest_blueprint",       "oinc", 100 },   
                            { "molehat_blueprint",              "oinc", 30 },
                            { "beargervest_blueprint",          "oinc", 50 },  
                            { "ox_flute_blueprint",             "oinc", 50 },  
                        },                                                  
    ["pig_shop_academy"] = {
                        },
}

AddComponentPostInit("shopinterior",function(ShopInterior)

function ShopInterior:GetNewProduct(shoptype)
    if GLOBAL.GetAporkalypse() and GLOBAL.GetAporkalypse():GetFiestaActive() and _SHOPTYPES[shoptype.."_fiesta"] then
        shoptype = shoptype.."_fiesta"
    end
    local items = _SHOPTYPES[shoptype]
    if items then
        local itemset = GLOBAL.GetRandomItem(items)
        return itemset
    end
end

end)

AddComponentPostInit("minionspawner",function(MinionSpawner)
function MinionSpawner:CheckTileCompatibility(tile)
local _validtiletypes = self.validtiletypes
	for k,v in pairs(self.validtiletypes) do
		if v == 31 or v == 32 or v == 33 then
			doesntAlreadyExist = false
		else
            doesntAlreadyExist = true
		end
		end
		if doesntAlreadyExist then
			table.insert(_validtiletypes, 31)
			table.insert(_validtiletypes, 32)
			table.insert(_validtiletypes, 33)
		end
	for k,v in pairs(self.validtiletypes) do
		if v == tile then
			return true
		end
	end
end
end)

AddComponentPostInit("banditmanager",function(Banditmanager)
function Banditmanager:GetLoot()
	local temploot = {}

	local treasurelist = {
		{	
			weight = 50,
			loot = {
				tunacan = 4,
				oinc10 = 1,
				meat_dried = 2,		
			},
		},
		
		{	
			weight = 30,
			loot = {
				goldnugget = 4,
				alloy = 1,
				meat_dried = 2,
				oinc = 5,
			},
		},

		{	
			weight = 30,
			loot = {
				trinket_17 = 1,
				oinc = 5,
				sewing_kit = 1,		
				telescope = 1,
				meat_dried = 1,
			},
		},	

		{	
			weight = 20,
			loot = {
				meat_dried = 2,
				oinc = 15,	
				meat = 2,
				oinc10 = 1,				
			},
		},

		{	
			weight = 20,
			loot = {
				armor_metalplate = 1,
				halberd = 1,	
				metalplatehat = 1,
				oinc10 = 2,	
			},
		},

		{	
			weight = 10,
			loot = {
				drumstick = 2,
				oinc = 15,	
				oinc10 = 2,
				tunacan = 1,
				monstermeat = 1,
			},
		},
		{	
			weight = 10,
			loot = {
				oinc10 = 5,
				pigskin = 2,		
			},
		},	
		{	
			weight = 10,
			loot = {
				oinc10 = 3,
				pigskin = 4,		
			},
		},
		{	
			weight = 10,
			loot = {
				fabric = 6,
				oinc10 = 2,
				cork_bat = 1,
			},
		},
		{	
			weight = 10,
			loot = {
				oinc100 = 1,
				powcake = 1,
			},
		},
		{	
			weight = 5,
			loot = {
				oinc100 = 2,
				powcake = 1,
			},
		},
		{	
			weight = 1,
			loot = {
				oinc100 = 10,
				bonestew = 1,
				powcake = 2,
			},
		},		
	}	

	local range = 0

	for i,set in ipairs(treasurelist) do
		range = range + set.weight
	end

	local final = math.random(1,range)
	print("BANDIT MAP", range,final)
	range = 0
	for i,set in ipairs(treasurelist) do

		range = range + set.weight
		print("range",range)
		if range >= final then
			for p,n in pairs(set.loot) do
				if not temploot[p] then
					temploot[p] = n
				else
					temploot[p] = temploot[p] +n
				end
			end
			break
		end
	end	

	for p, n in pairs(self.loot) do		
		if not temploot[p] then			
			temploot[p] = n
		else
			temploot[p] = temploot[p] +n
		end
	end
	return temploot 
end
end)


local fabricRecipeHamlet = Recipe("fabric", {Ingredient("bamboo", 3)}, GLOBAL.RECIPETABS.REFINE,  TECH.SCIENCE_ONE, {GLOBAL.RECIPE_GAME_TYPE.SHIPWRECKED, GLOBAL.RECIPE_GAME_TYPE.VANILLA, GLOBAL.RECIPE_GAME_TYPE.ROG ,GLOBAL.RECIPE_GAME_TYPE.PORKLAND})

